﻿Public Class Model
    Inherits NotificationObject

    Private _results As New ObservableCollection(Of WikipediaItem)()
    Public ReadOnly Property Results As ObservableCollection(Of WikipediaItem)
        Get
            Return Me._results
        End Get
    End Property

    Public Sub Search(keyword As String)
        Me.Results.Clear()

        Task.Factory.StartNew(Sub()
                                  Try
                                      For Each result In WikipediaApi.CallApi(keyword)
                                          Me.Results.Add(result)
                                      Next
                                  Catch ex As Exception
                                      Me.OnApiError(New ApiErrorEventArgs() With {.Message = ex.Message})
                                  End Try
                              End Sub)
    End Sub

#Region "ApiErrorイベント"
    Dim ApiErrorEventHandlers As New List(Of EventHandler(Of ApiErrorEventArgs))
    Public Custom Event ApiError As EventHandler(Of ApiErrorEventArgs)
        AddHandler(ByVal value As EventHandler(Of ApiErrorEventArgs))
            ApiErrorEventHandlers.Add(value)
        End AddHandler
        RemoveHandler(ByVal value As EventHandler(Of ApiErrorEventArgs))
            ApiErrorEventHandlers.Remove(value)
        End RemoveHandler
        RaiseEvent(ByVal sender As Object, ByVal e As ApiErrorEventArgs)
            For Each h In ApiErrorEventHandlers
                h(sender, e)
            Next
        End RaiseEvent
    End Event

    Private _ApiErrorEvent As Notificator(Of ApiErrorEventArgs)
    Public Property ApiErrorEventNotificator() As Notificator(Of ApiErrorEventArgs)
        Get
            If _ApiErrorEvent Is Nothing Then
                _ApiErrorEvent = New Notificator(Of ApiErrorEventArgs)()
            End If
            Return _ApiErrorEvent
        End Get
        Set(ByVal value As Notificator(Of ApiErrorEventArgs))
            _ApiErrorEvent = value
        End Set
    End Property

    Protected Sub OnApiError(ByVal e As ApiErrorEventArgs)
        RaiseEvent ApiError(Me, e)
        ApiErrorEventNotificator.Raise(e)
    End Sub
#End Region

End Class
