﻿Public Class WikipediaItem
    Public Property Language As String
    Public Property Id As Integer
    Public Property Url As String
    Public Property Title As String
    Public Property Body As String
    Public Property Length As Integer
    Public Property Redirect As Boolean
    Public Property Strict As Boolean
    Public Property DateTime As Date

    Public Shared Function FromXml(xml As XElement) As WikipediaItem
        Return New WikipediaItem() With {
            .Language = xml.<language>.Value,
            .Id = Integer.Parse(xml.<id>.Value),
            .Url = xml.<url>.Value,
            .Title = xml.<title>.Value,
            .Body = xml.<body>.Value.Replace("<br/>", " "),
            .Length = Integer.Parse(xml.<length>.Value),
            .Redirect = xml.<redirect>.Value = "1",
            .Strict = xml.<strict>.Value = "1",
            .DateTime = Date.Parse(xml.<datetime>.Value)
        }
    End Function
End Class
